PROGRAM_NAME='Base_64_Encode'


// Code in this file was copied from i!-EquipmentMonitorOut

DEFINE_CONSTANT

(* Base64 *)
// Limits
#IF_NOT_DEFINED ENCR_MAX_ENC_LEN
ENCR_MAX_ENC_LEN      = 1000
#END_IF
#IF_NOT_DEFINED ENCR_MAX_DEC_LEN
ENCR_MAX_DEC_LEN      = 750
#END_IF


DEFINE_VARIABLE

(* Base 64 *)
VOLATILE CHAR cEncrBase64[] = {
                               'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H',   //  0 to  7
                               'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P',   //  8 to 15
                               'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',   // 16 to 23
                               'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f',   // 24 to 31
                               'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n',   // 32 to 39
                               'o', 'p', 'q', 'r', 's', 't', 'u', 'v',   // 40 to 47
                               'w', 'x', 'y', 'z', '0', '1', '2', '3',   // 48 to 55
                               '4', '5', '6', '7', '8', '9', '+', '/'    // 56 to 63
                              }



(****************************)
(* NAME: EncrBase64Encode   *)
(***********************************************************)
(***********************************************************)
DEFINE_FUNCTION CHAR[ENCR_MAX_ENC_LEN] EncrBase64Encode(CHAR cDecStr[])
STACK_VAR
CHAR    cDecodeStr[ENCR_MAX_DEC_LEN]
CHAR    cEncodeStr[ENCR_MAX_ENC_LEN]
INTEGER nLoop
INTEGER nTemp
CHAR    cIdx1
CHAR    cIdx2
CHAR    cIdx3
CHAR    cIdx4
CHAR    cByte1
CHAR    cByte2
CHAR    cByte3
CHAR    cChar1
CHAR    cChar2
CHAR    cChar3
CHAR    cChar4
{
  // Copy string and pad
  cDecodeStr = cDecStr
  nTemp = LENGTH_STRING(cDecodeStr) % 3
  IF (nTemp <> 0)
  {
    cDecodeStr[LENGTH_STRING(cDecodeStr)+1] = 0
    cDecodeStr[LENGTH_STRING(cDecodeStr)+2] = 0
    cDecodeStr[LENGTH_STRING(cDecodeStr)+3] = 0
  }

  // Encode
  FOR (cEncodeStr = "", nLoop = 1; nLoop <= LENGTH_STRING(cDecodeStr); nLoop = nLoop + 3)
  {

    // Get bytes
    cByte1 = cDecodeStr[nLoop]
    cByte2 = cDecodeStr[nLoop+1]
    cByte3 = cDecodeStr[nLoop+2]

    // Get index
    cIdx1  =  TYPE_CAST(((cByte1 & $FC) >> 2) + 1)
    cIdx2  =  TYPE_CAST((((cByte2 & $F0) >> 4) | ((cByte1 & $03) << 4)) + 1)
    cIdx3  =  TYPE_CAST((((cByte3 & $C0) >> 6) | ((cByte2 & $0F) << 2)) + 1)
    cIdx4  =  TYPE_CAST(  (cByte3 & $3F) + 1)

    // Get chars
    cChar1 = cEncrBase64[cIdx1]
    cChar2 = cEncrBase64[cIdx2]
    cChar3 = cEncrBase64[cIdx3]
    cChar4 = cEncrBase64[cIdx4]

    // Pad?
    IF (LENGTH_STRING(cDecodeStr) < (nLoop+1))
      cChar3 = $3D // '='
    IF (LENGTH_STRING(cDecodeStr) < (nLoop+2))
      cChar4 = $3D // '='

    // Build string
    cEncodeStr = "cEncodeStr, cChar1, cChar2, cChar3, cChar4"
  }
  RETURN cEncodeStr;
}
